--@Author: Alex2009, Sven777b
--@Web: www.ls-landtechnik.de, www.alex2009.de

fenceDoorPlaceable = {};
fenceDoorPlaceable_mt = Class(fenceDoorPlaceable, Placeable);
InitObjectClass(fenceDoorPlaceable, "fenceDoorPlaceable");

function fenceDoorPlaceable:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, fenceDoorPlaceable_mt);
    registerObjectClassName(self, "fenceDoorPlaceable");
    return self;
end;

function fenceDoorPlaceable:delete()
    removeTrigger(self.doorTrigger);
    unregisterObjectClassName(self);
    fenceDoorPlaceable:superClass().delete(self);
end;

function fenceDoorPlaceable:deleteFinal()
    fenceDoorPlaceable:superClass().deleteFinal(self);
end;

function fenceDoorPlaceable:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
    if not fenceDoorPlaceable:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
        return false;
    end;
    local xmlFile = loadXMLFile("TempXML", xmlFilename);
    self.doorTrigger = Utils.indexToObject(self.nodeId, getXMLString(xmlFile, "placeable.FenceDoorTrigger#index"));
    addTrigger(self.doorTrigger, "triggerCallback", self);    
    self.DoorLeft = getChildAt(getChildAt(self.doorTrigger, 0),1);
    self.DoorRight = getChildAt(getChildAt(self.doorTrigger, 0),0);
    self.count = 0; 
    self.angle = math.rad(0);
    self.maxAngle = math.rad(90);
    self.minAngle = math.rad(0);
    self.isEnabled = true;
    delete(xmlFile);
    return true;
end;

function fenceDoorPlaceable:update(dt)
    local old = self.angle;
    if self.count > 0 then
        if self.angle < self.maxAngle then
            self.angle = self.angle + dt*0.0004;    
        end;
    else
        if self.angle > self.minAngle then
            self.angle = self.angle - dt*0.0004;    
        end;
    end;
        
    if old ~= self.angle then
        local x,y,z = getRotation(self.DoorLeft);
        setRotation(self.DoorLeft,x,self.angle,z);
        local x,y,z = getRotation(self.DoorRight);
        setRotation(self.DoorRight,x,-self.angle,z);
    end;
end;

function fenceDoorPlaceable:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay)  
    if onEnter and self.isEnabled then
        self.count = self.count + 1;
    elseif onLeave then
        self.count = self.count - 1;
    end;
end;
registerPlaceableType("fenceDoorPlaceable", fenceDoorPlaceable);